7070a5f5b73c587867b3e3d0a13ea9e6a9ad1a31
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
13 +-----------------------------------------------------------------------+
14
15 GCC 4.4 & BINUTILS 2.21
16 -----------------------
17
18 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
19 been made DragonFly's default Binutils.
20
21 That means that any settings that set CCVER to 'gcc44' are not needed
22 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
23 GCC 4.1.
24
25 It also means that 'binutils221' as a value for BINUTILSVER has no
26 effect anymore. 2.17 has been removed and 'binutils220' is available
27 as an option.
28
29 The NO_GCC44 option has been removed and will not affect the build
30 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
31 building in a similar fashion.
32
33 Note that you must do a full buildworld/buildkernel for upgrading.
34
35 pkg_radd settings
36 -----------------
37
38 The config file for pkg_radd has moved from /etc/settings.conf to 
39 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
40 if this is needed.  This warning only applies if /etc/settings.conf 
41 exists.  pkg_radd will continue to work with defaults.
42
43 +-----------------------------------------------------------------------+
44 +         20100927                                                      +
45 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
46 +-----------------------------------------------------------------------+
47
48 OpenSSL
49 --------
50
51 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
52 This shouldn't break any 3rd-party software, but you'll need to recompile your
53 3rd-party software if you want it to link against the new version of OpenSSL.
54
55 Loader
56 -------
57
58 A new loader (dloader) has been added which better handles booting from
59 multiple kernel/module versions.
60
61 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
62
63         cd /usr/src
64         make buildworld
65         make installworld
66         make upgrade
67         make buildkernel KERNCONF=<KERNELNAME>
68         make installkernel KERNCONF=<KERNELNAME>
69
70 Note that you must installworld and run the 'upgrade' target before
71 installing the new kernel.
72
73 BIND
74 -----
75
76 BIND has been removed from the base system.  The ldns and drill tools have 
77 been added for basic functionality.  Use 'drill' where you would normally 
78 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
79 net/bind95, net/bind96, or net/bind97 as of this writing.
80
81 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
82 include BIND as a pkgsrc package.
83
84 +-----------------------------------------------------------------------+
85 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
86 +                               GENERAL                                 +
87 +-----------------------------------------------------------------------+
88
89 Instructions on how to obtain and maintain DragonFly source code using git
90 are in the development(7) manual page.
91
92 To upgrade a DragonFly system from sources you run the following sequence:
93
94         cd /usr/src
95         make buildworld
96         make buildkernel KERNCONF=<KERNELNAME>
97         make installkernel KERNCONF=<KERNELNAME>
98         make installworld
99
100 You will also want to run the 'upgrade' target to upgrade your /etc and the
101 rest of your system.  The upgrade target is aware of stale files created by
102 older DragonFly installations and should delete them automatically.
103
104         make upgrade
105
106 See the build(7) manual page for further information.
107
108 Once you've done a full build of the world and kernel you can do incremental
109 upgrades of either by using the 'quickworld' and 'quickkernel' targets
110 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
111 the quick targets, try updating your repo first, and then a full buildworld
112 and buildkernel as shown above, before asking for help.
113
114 +-----------------------------------------------------------------------+
115 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
116 +-----------------------------------------------------------------------+
117
118 In 2.1 kernel and modules has moved to boot directory.  For most cases
119 this is handled automatically by 'make upgrade'.  A few cases needs manual
120 intervention:
121
122  * When installing a kernel without first doing a make buildworld,
123    installworld and upgrade to the same DESTDIR as kernel:
124    make DESTDIR/boot directory and move kernel and modules into this boot
125    directory; also move kernel.old and modules.old.
126    Typical example is vkernel(7), use (no modules used):
127
128         cd /var/vkernel
129         mkdir boot
130         chflags noschg kernel
131         mv kernel kernel.old boot
132         chflags schg boot/kernel
133         
134  * When using a boot-only partition, /boot/loader.rc needs to be edited:
135    delete occurrences of '/boot/'.
136    These occurences can normally be deleted in any case, see loader(8).
137
138 +-----------------------------------------------------------------------+
139 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
140 +-----------------------------------------------------------------------+
141
142 In 1.9 major changes to the disk management infrastructure have taken
143 place.  make upgrade may not catch all of your disk devices in /dev,
144 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
145 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
146 and MAKEDEV no longer exists.
147
148 The biggest changes in 1.9 are:
149
150 (1) That whole-slice devices such as da0s1 no longer share the same device
151     id as partition c devices such as da0s1c.
152
153 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
154     with no snooping or reserved sectors.  Consequently you cannot run
155     disklabel on this device.  Instead you must run disklabel on a
156     whole-slice device.
157
158 (3) The 'compatibility' partitions now use slice 0 in the device name,
159     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
160     accessing the disklabel for the compatibility partitions must be
161     done via slice 0 (da0s0).
162
163 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
164     and CCD now run through the disk management layer and are assigned
165     real disk management devices.   VN and CCD in particular do not usually
166     use a MBR and disklabels must be accessed through the compatibility
167     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
168     don't name it 'ccd0s0' in the config file.
169
170 Generally speaking, you have to get used to running fdisk and disklabel on
171 the correctly specified device names.  A lot of the wiggle, such as running
172 disklabel on a partition, has been removed.
173
174 +-----------------------------------------------------------------------+
175 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
176 +-----------------------------------------------------------------------+
177
178 > Kerberos IV
179 -------------
180
181 Kerberos IV (eBones) was removed from the tree, please consider moving to
182 Kerberos 5 (Heimdal).
183
184 > Package Management System
185 ---------------------------
186
187 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
188 management system.  The necessary tools to build and maintain packages
189 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
190 directories are in your PATH variable.
191
192 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
193 the tarball from NetBSD:
194
195         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
196         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
197
198 This tree can then be kept up to date with cvs update:
199
200         cd /usr/pkgsrc; cvs up
201
202 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
203 build and install the pkgsrc bootstrap manually:
204
205         cd /usr/pkgsrc/bootstrap
206         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
207
208 +-----------------------------------------------------------------------+
209 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
210 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
211 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
212 +-----------------------------------------------------------------------+
213
214 The compatibility shims for the build environment have been removed, you
215 have to update to DragonFly 1.2 release branch first.
216
217 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
218 The existing configuration can be converted using /etc/pam.d/convert.sh.
219 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
220 the pam_skey.so module was retired, you have to remove it manually from
221 your configuration, when you convert it.
222
223 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
224 ---------------------
225
226 The following users may be missing from your password file.  Use vipw and
227 add any that are missing:
228
229 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
230 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
231
232 The following groups may be missing from your group file.  Use vi /etc/group
233 and add any that are missing:
234
235 smmsp:*:25:
236 authpf:*:63:
237 _pflogd:*:64:
238
239
240 > Upgrading to DragonFly from FreeBSD
241 ---------------------
242
243 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
244 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
245 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
246 make depend information, it starts from scratch, so no pre-cleaning of the
247 object hierarchy is necessary.
248
249         # get the CVS repository (it is placed in /home/dcvs, 500MB).
250         # Please use the -h option and a mirror site to pull the 
251         # initial repository, but feel free to use the main repository
252         # machine to pull updates.
253         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
254         # install the source from the CVS hierarchy (remove preexisting
255         # FreeBSD src first) (500MB)
256         cd /usr
257         rm -rf src
258         cvs -R -d /home/dcvs checkout -P src
259
260         # build it (500MB used in /usr/obj)
261         #
262         cd /usr/src
263         make buildworld
264         make buildkernel KERNCONF=<KERNELNAME>
265
266 Once you have built DragonFly you have to install it over FreeBSD.  Since
267 DragonFly does not track changes made by FreeBSD to its include file 
268 hierarchy and include file pollution can cause all sorts of unexpected
269 compilation issues to come up, it is best to wipe your include hierarchy
270 prior to installing DragonFly.  Note that you should not wipe any installed
271 FreeBSD header files or binaries until after you have successfully completed
272 the build steps above.
273
274         rm -rf /usr/include
275         mkdir /usr/include
276         make installkernel KERNCONF=<KERNELNAME>
277         make installworld
278
279 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
280 will unconditionally upgrade the /etc files that sysops do not usually
281 mess around with, such as the files in /etc/rc.d.  It will also remove any
282 obsolete files such as utilities and manpages that have been removed from
283 the system since the version you're coming from.  If you are unsure we 
284 recommend that you make a backup of at least your /etc before applying
285 this step.  Note that DragonFly's RC system is basically RCNG from
286 FreeBSD-5, but there are some differences in the contents of the RC files.
287
288         make upgrade
289
290 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
291 Doing so might leave your system in an unusable state.
292
293 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
294 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
295 report these files to the DragonFly developers so that they can be added to
296 the 'upgrade' target.
297